(*$Use32+*)
unit filter;

interface

const
  umleitung:boolean=false;

procedure pruefe_umleitung;
procedure Write(const s:string);
procedure WriteLn(const s:string);

implementation

uses
  VpSysLow,
  VpUtils;

const
  zeile         :string ='';
  spalte        :word   =1;

procedure pruefe_umleitung;
  begin
    if not IsFileHandleConsole(SysFileStdOut) then
      begin
        umleitung:=true;

        Close(Input);
        Close(Output);

        TextModeRead := Open_Access_ReadOnly OR open_share_DenyNone;
        Assign(Input,'');
        Reset(Input);

        TextModeReadWrite := Open_Access_ReadWrite OR open_share_DenyNone;
        Assign(Output,'');
        Rewrite(Output);
      end;
  end;

procedure Write(const s:string);
  var
    z:word;

  procedure zeichen_eintragen(const zeichen:char);
    begin
      if spalte>High(zeile) then Exit;
      while Length(zeile)<spalte do
        zeile:=zeile+' ';
      zeile[spalte]:=zeichen;
    end;

  begin
    if not umleitung then
      begin
        zeile:=s;
        while Pos(^Z,zeile)<>0 do
          Delete(zeile,Pos(^Z,zeile),1);
        System.Write(zeile);
        Exit;
      end;

    for z:=1 to Length(s) do
      case s[z] of
        #7:
          ;

        #8:
          if spalte>1 then
            Dec(spalte);
        #9:
          repeat
            zeichen_eintragen(' ');
            Inc(spalte);
          until (spalte and 8)=1;

        #10:
          begin
            System.WriteLn(zeile);
            zeile:='';
            spalte:=1;
          end;

        #13:
          spalte:=1;

        #26: (* ^Z *)
          begin
            System.Write(zeile);
            zeile:='';
          end;

      else
        zeichen_eintragen(s[z]);
        Inc(spalte);
      end;

  end;

procedure WriteLn(const s:string);
  begin
    Write(s);
    Write(#13#10);
  end;

end.

