procedure relokations_kompressor;
  var
    relo2_puffer                :pByteArray;
    z1,z2                       :longint;
    position,alte_position      :longint;
    page                        :longint;
    page_pos                    :longint;
    l1_ofs                      :longint;
    position_dummy_fixup,
    page_dummy_fixup,
    ofs_dummy_fixup             :longint;

  begin
    status(textz_relopack^);
    GetMem(relo2_puffer,le_relo_puffer_position);

    z1:=0;
    z2:=0;
    alte_position:=0;

    // fr alle Seiten
    for page:=1 to page_map_table_entries do
      // noch nicht die Daten der nchsten Seite
      while z1<Fixup_page_table_z^[page+1] do
        begin
          page_pos:=MemW[Ofs(le_relo_puffer^[z1+2])];

          if le_relo_puffer^[z1+1]=0 then (* $00=klein $10=gross *)
            begin
              l1_ofs:=MemW[Ofs(le_relo_puffer^[z1+5])];
              Inc(z1,7);
            end
          else
            begin
              l1_ofs:=MemL[Ofs(le_relo_puffer^[z1+5])];
              Inc(z1,9);
            end;

          // Fixup nicht zum 2. mal (-3,-2,-1 -> $ffd,$ffe,$fff)
          if page_pos<4096 then
            begin
              position:=ziel_va+page_pos+(page-1)*4096;

              // die allererste Stelle
              if z2=0 then
                begin
                  (* relativ zum Anfang des Programmspeichers (nicht zum Eintrittspunkt) *)
                  MemL[Ofs(relo2_puffer^[z2])]:=position;
                  Inc(z2,4);
                end
              else

                // Abstand klein genug um als Byte abgespeichert zu werden?
                 if (0<=position-alte_position) and
                   (position-alte_position<254) then
                  begin
                    relo2_puffer^[z2]:=position-alte_position;
                    Inc(z2);
                  end
                else // longint ntig, Prfix 254
                  begin
                    relo2_puffer^[z2]:=254;
                    Inc(z2);
                    MemL[Ofs(relo2_puffer^[z2])]:=position-alte_position;
                    Inc(z2,4);
                  end;
              alte_position:=position+4;
            end;
        end;

    // Ende markieren
    relo2_puffer^[z2]:=$ff;
    Inc(z2);

    relopacklaenge:=z2;

    // Position eintragen
    z1:=(*info_block_tabelle[startcode].ofs;*)eip_pos;
    while not (    (le_image^[z1+3]=Ord('R'))
               and (le_image^[z1+2]=Ord('E'))
               and (le_image^[z1+1]=Ord('L'))
               and (le_image^[z1+0]=Ord('O'))) do
      Inc(z1);
    Meml[Ofs(le_image^[z1])]:=info_block_tabelle[alles_zusammen].phys_laenge;

    // mehr Speicher anfordern
    ReAllocMem(le_image,info_block_tabelle[alles_zusammen].phys_laenge+relopacklaenge);
    Move(relo2_puffer^,
         le_image^[info_block_tabelle[alles_zusammen].phys_laenge],
         relopacklaenge);
    // zwischenspeicher freigeben
    Dispose(relo2_puffer);
    relo2_puffer:=nil;

    // Speicherbereich vergrern
    Inc(info_block_tabelle[alles_zusammen].phys_laenge,relopacklaenge);
    if info_block_tabelle[alles_zusammen].log_laenge<info_block_tabelle[alles_zusammen].phys_laenge then
      info_block_tabelle[alles_zusammen].log_laenge:=info_block_tabelle[alles_zusammen].phys_laenge;

    with le_obj_1 do
      begin
        virtual_size_in_bytes:=info_block_tabelle[alles_zusammen].log_laenge;
        page_map_entries:=pages(info_block_tabelle[alles_zusammen].phys_laenge);
      end;

    (* eine Relokation .. fr XE ("user break") *)
    (* bei 'startcode_relopack__code_schon_vorhanden' ist kein startcode
       vorhanden, also phys_laenge unbekannt ..
       aber bei eip_pos-1 gibt es einen Sprung (z.B. $eb $56) ber
       den Code also kann die Lnge trotzdem berechnet werden ... *)
    if startcodewahl=startcode_relopack__code_schon_vorhanden then
      position_dummy_fixup:=eip_pos+le_image^[eip_pos-1]-4
    else
      position_dummy_fixup:=info_block_tabelle[startcode].ofs+
                           +info_block_tabelle[startcode].phys_laenge-4;
    MemL[Ofs(le_image^[position_dummy_fixup])]:=0;

    (* Vermeiden das die Reloaktion fr 2 Seiten erzeugt werden mte *)
    if (position_dummy_fixup mod 4096)>=4096-4 then
      Dec(position_dummy_fixup,4);

    // 1
    page_dummy_fixup:=(position_dummy_fixup div 4096)+1;
    // position_dummy_fixup<4096-3!!
    ofs_dummy_fixup := position_dummy_fixup mod 4096;

    le_relo_puffer_position:=7;
    ReAllocMem(le_relo_puffer,le_relo_puffer_position);
    le_relo_puffer^[0]                  :=$07;  // 32 BIT OFFSET
    le_relo_puffer^[1]                  :=$00;  // <64K OFFSET
    MemW[Ofs(le_relo_puffer^[2])]       :=ofs_dummy_fixup;
    le_relo_puffer^[4]                  :=1;    // CODE/DATA Object
    MemW[Ofs(le_relo_puffer^[5])]       :=0;    // CODE/DATA Object OFS 0


    // alle Tabellen vergern
    page_map_table_entries:=le_obj_1.page_map_entries;

    if output_format=le
      then
        begin
          ReAllocMem  (Object_Page_Map_Table_feld_z ,page_map_table_entries*SizeOf(le_page_map_entry_typ));
          FillChar(Object_Page_Map_Table_feld_z^,page_map_table_entries*SizeOf(le_page_map_entry_typ),0);
          for z1:=1 to page_map_table_entries do
            with le_page_map_entry_feld_z_typ(Object_Page_Map_Table_feld_z)^[z1] do
              index_into_fixup_table:=pack24bit(z1);
        end
      else
        begin
          ReAllocMem  (Object_Page_Map_Table_feld_z ,page_map_table_entries*SizeOf(lx_page_map_entry_typ));
          FillChar(Object_Page_Map_Table_feld_z^,page_map_table_entries*SizeOf(lx_page_map_entry_typ),0);
          for z1:=1 to page_map_table_entries do
            with lx_page_map_entry_feld_z_typ(Object_Page_Map_Table_feld_z)^[z1] do
              begin
                index_into_fixup_table:=z1-1;
                data_size:=$1000
              end;
          with lx_page_map_entry_feld_z_typ
               (Object_Page_Map_Table_feld_z)^[page_map_table_entries] do
           data_size:=info_block_tabelle[alles_zusammen].phys_laenge mod 4096;
        end;

    ReAllocMem(Fixup_page_table_z ,(page_map_table_entries+1)*SizeOf(longint));
    for z1:=1 to page_dummy_fixup do
      Fixup_page_table_z^[z1]:=0;
    for z1:=page_dummy_fixup+1 to page_map_table_entries+1 do
      Fixup_page_table_z^[z1]:=le_relo_puffer_position;

  end;

