@ECHO OFF
REM
REM Make an OS/2 Exe from Pascal Source
REM %1.PAS=main program file
REM %2    =target directory
REM

SET VPBASE=E:\VP21
SET OUT=%VPBASE%\OUT.OS2

REM  check parameters
IF [%1]==[] GOTO FEHLER
IF [%2]==[] GOTO FEHLER

REM  check if source rely exist
IF NOT EXIST %1.PAS GOTO DATEI_FEHLT

REM  del old exe,..
IF EXIST %OUT%\UNITS\%1.LNK DEL %OUT%\UNITS\%1.LNK
IF EXIST %OUT%\UNITS\%1.VPI DEL %OUT%\UNITS\%1.VPI
IF EXIST %OUT%\UNITS\%1.OBJ DEL %OUT%\UNITS\%1.OBJ
IF EXIST %OUT%\%1.EXE       DEL %OUT%\%1.EXE

REM  exist an complier config file in current directory ?
IF EXIST VPC.CFG SET CFG1=@VPC.CFG

REM  compile
%VPBASE%\BIN.W32\VPC.EXE -CO %1.PAS %CFG1% %3 %4 %5 %6 %7 %8 %9

REM  erase temp files
IF EXIST %OUT%\UNITS\%1.LNK DEL %OUT%\UNITS\%1.LNK
IF EXIST %OUT%\UNITS\%1.VPI DEL %OUT%\UNITS\%1.VPI
IF EXIST %OUT%\UNITS\%1.OBJ DEL %OUT%\UNITS\%1.OBJ

REM  compile successful ?
IF NOT EXIST %OUT%\%1.EXE GOTO ENDE

REM  compress/bind stub
SIEGEL %OUT%\%1.EXE

REM  delete existing target executable in current dir
IF EXIST %2%1.EXE DEL %2%1.EXE

REM  move result if needed
IF NOT [%OUT%\]==[%2] COPY %OUT%\%1.EXE %2%1.EXE
IF NOT [%OUT%\]==[%2] DEL  %OUT%\%1.EXE
GOTO ENDE

:FEHLER
ECHO %1,%2
ECHO PASVP (Quelltext) ohne .PAS
GOTO ENDE

:DATEI_FEHLT
ECHO %1.PAS fehlt
GOTO ENDE

:ENDE
