#!/bin/bash

function chkerrorlevel() {
        if [ $? != 0 ] ; then
           echo "--- error detected ($?) ! aborting... ---"
           exit $?
        fi
}

echo
echo "PE2ELF Build Script                           (C) 2008 Angels Holocaust"
echo
TARGET="pe2elf"
VPBASE="/media/hda10/vp"
VPPATH="$VPBASE/bin.lnx"
VPTARGET="L:lnx:LINUX"
VPINCPATH="../zst/"
#VPOPT="-B -C$VPTARGET -V$VPPATH/vp.vpo -I$VPINCPATH -L$VPINCPATH -R$VPINCPATH -U$VPINCPATH -E$VPPATH"
VPOPT="-B -C$VPTARGET -V$VPPATH/vp.vpo -I$VPINCPATH -L$VPINCPATH -R$VPINCPATH -U$VPINCPATH -E. -GD"

#if exist "%vpbase%\bin.os2\vpc.exe" goto continue
#
#echo   Cannot execute; VPBase setting is probably incorrect.  Please modify this
#echo   script to contain the correct location of your VP installation.
#echo.
#pause
#goto end
#
#:continue

#echo "$VPPATH/vpc $VPOPT $TARGET.pas"
$VPPATH/vpc $VPOPT $TARGET.pas
chkerrorlevel

$VPPATH/pe2elf -t:Linux $TARGET.exe
chkerrorlevel

#./$TARGET
chkerrorlevel

# for debugging...
$VPPATH/vpc $VPOPT hello.pas
chkerrorlevel
rm 0
./pe2elf -v -t:Linux hello.exe 0
chkerrorlevel
readelf -a 0 > 0.readelf
chkerrorlevel

#cp $TARGET $VPPATH/
chkerrorlevel

#:end
