@echo off
cls
echo.
echo   PE2ELF Build Script                           (C) 2008 Angels Holocaust
echo.
REM VPT: 2009.04.12 multiple targets added
REM
REM if "%NOPAUSE%"=="1" goto no_pause
REM echo   Under NT, it must be run in a separate session ("cmd.exe /e:2048") to
REM echo   make environment space available; in Win95/98, run "command.com /e:2048".
REM echo.
REM pause
REM :no_pause

set TARGET=pe2elf
set VPBASE=E:\VP21
set VPPATH=%VPBASE%\BIN.W32
set VPUNITS=%VPBASE%\lib.%%p;%VPBASE%\units.%%p;..\zst
set VPOPT=-B -U%VPUNITS% -L%VPUNITS% -R%VPBASE%\res.%%p -O%VPBASE%\out.%%p\units -E.
if exist "%vppath%\vpc.exe" goto continue

echo   Cannot execute; VPBase setting is probably incorrect.  Please modify this
echo   script to contain the correct location of your VP installation.
echo.
pause
goto end

:error
echo "--- error detected! aborting... ---"
pause
goto end

:continue
%VPPATH%\vpc.exe -CW %VPOPT% %TARGET%.pas
if errorlevel 1 goto error
copy /Y %TARGET%.exe %VPBASE%\BIN.W32
if errorlevel 1 goto error

%VPPATH%\vpc.exe -CO %VPOPT% %TARGET%.pas
if errorlevel 1 goto error
copy /Y %TARGET%.exe %VPBASE%\BIN.OS2
if errorlevel 1 goto error

%VPPATH%\vpc.exe -CW:D32:DPMI32 %VPOPT% %TARGET%.pas
if errorlevel 1 goto error
%VPPATH%\pe2le.exe %TARGET%.exe /* /S:wdosxle.exe
del %TARGET%.exe
copy /Y %TARGET%.com %VPBASE%\BIN.D32
if errorlevel 1 goto error

%VPPATH%\vpc.exe -CL %VPOPT% %TARGET%.pas
if errorlevel 1 goto error
%VPPATH%\pe2elf.exe -t:Linux %TARGET%.exe
del %TARGET%.exe
copy /Y %TARGET% %VPBASE%\BIN.LNX
if errorlevel 1 goto error

echo Done!

:end
